package minischeme

class Label(val name: String) extends Representable {
  def representation: String = name
}

object Label {
  private val labelCounters = scala.collection.mutable.HashMap[String,Int]()

  def newLabel(): Label = newLabel("L")

  def newLabel(prefix: String): Label = {
    val sanePrefix = prefix.replace(':','_')
    val count = labelCounters.getOrElse(sanePrefix, 1)
    labelCounters += Pair(sanePrefix, (count + 1))
    new Label(sanePrefix + count)
  }
}
