#ifndef __ENGINE_THREADED_H
#define __ENGINE_THREADED_H

#include <inttypes.h>
#include "opcode.h"

#define REGS_COUNT 32
typedef unsigned short reg_idx_t;

extern char* engine_identity;

extern void engine_setup();
extern void engine_cleanup();

extern void engine_emit(opcode_t opcode);
extern void engine_emit_r(opcode_t opcode, reg_idx_t r);
extern void engine_emit_rr(opcode_t opcode, reg_idx_t ra, reg_idx_t rb);
extern void engine_emit_rc(opcode_t opcode, reg_idx_t r, intptr_t c);
extern void engine_emit_rrr(opcode_t opcode,
                            reg_idx_t ra,
                            reg_idx_t rb,
                            reg_idx_t rc);

extern void* engine_get_next_address();
extern void engine_patch(void* instr_to_patch, void* target_instr);

extern int engine_run();
extern intptr_t engine_get_register(reg_idx_t r);

#endif // __ENGINE_THREADED_H
